/**************************************************/
/*                                                */
/* Copyright (C) 1997 Michael Radchenko           */
/* Portions Copyright (C) 2009 MarinovSoft        */
/*                                                */
/**************************************************/
#include <stdio.h>
#include <string.h>
#include "service.h"
#include "msbin.h"
unsigned char ReadByte(FILE *f)
{
   unsigned char B = 0;
   unsigned char J;
   unsigned char Arr[11];
   unsigned char Arr1[8] =
   {
      0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80
   };

   fread(&Arr, sizeof(Arr), 1, f);
   for(J = 1; J <= 8; J++)
   {
      if(Arr[J] == '1')
      {
         B = B | Arr1[J - 1];
      }
   }
   return(B);
}
char *ReadLine(FILE *f, char *S)
{
   unsigned char goon = 1;
   unsigned char forwarded = 0;
   unsigned char i;
   strcpy(S,"");
   while (goon)
   {
      if (forwarded!=0)
      {
         i = forwarded;
         forwarded = 0;
      }
      else
      {
         fread(&i,sizeof(i),1,f);
      }
      switch (i)
      {
         case 0x00:
         {
            goon = 0;
            break;
         }

         case 0x11:case 0x12:case 0x13:
         case 0x14:case 0x15:case 0x16:
         case 0x17:case 0x18:case 0x19:
         case 0x1A:case 0x1B:
         {
            char s1[10];
            i-=0x11;
            sprintf(s1,"%u",i);
            strcat(S,s1);
            break;
         }
         case 0x3A:
         {
            unsigned char j;
            fread(&j,sizeof(j),1,f);
            switch (j)
            {
               case 0xA2:
               {
                  strcat(S,"ELSE");
                  continue;
               }
               case 0x00:
               {
                  strcat(S,":");
                  goon = 0;
                  break;
               }
               default:
               {
                  strcat(S,":");
                  forwarded = j;
                  continue;
               }
            }
            break;
         }

         case 143:
         {
            strcat(S,"REM");
            do
            {
               unsigned char j;
               char s1[10];
               fread(&j,sizeof(j),1,f);
               if (j==0)
               {
                  goon = 0;
                  break;
               }
               sprintf(s1,"%c",j);
               strcat(S,s1);
            }
            while (1==1);
            break;
         }

         case 0x84:
         {
            strcat(S,"DATA");
            unsigned char inquote = 0;
            unsigned char j;
            char s1[10];
            do
            {
               fread(&j,sizeof(j),1,f);
               if (j==0)
               {
                  goon = 0;
                  break;
               }
               if ((j==':') && (inquote==0))
               {
                  forwarded = j;
                  continue;
               }
               sprintf(s1,"%c",j);
               strcat(S,s1);
               if (j=='"')
               {
                  if (inquote==0)
                  {
                     inquote=1;
                  }
                  else
                     inquote=0;
               }
            }
            while (1==1);
            break;
         }

         case 0x0D:
         case 0x0E:
         {
            unsigned short w;
            char s1[10];
            fread(&w,sizeof(w),1,f);
            sprintf(s1,"%u",w);
            strcat(S,s1);
            break;
         }

         case 0x0F:
         {
            unsigned char j;
            char s1[10];
            fread(&j,sizeof(j),1,f);
            sprintf(s1,"%u",j);
            strcat(S,s1);
            break;
         }
         case 0x0B:
         {
            unsigned short int w;
            char s1[10];
            fread(&w,sizeof(w),1,f);
            sprintf(s1,"%o",w);
            strcat(S,"&O");
            strcat(S,s1);
            break;
         }
         case 0x1C:
         {
            short int w;
            char s1[10];
            fread(&w,sizeof(w),1,f);
            sprintf(s1,"%i",w);
            strcat(S,s1);
            break;
         }

         case 0x0C:
         {
            unsigned short int w;
            char s1[10];
            fread(&w,sizeof(w),1,f);
            sprintf(s1,"%X",w);
            strcat(S,"&H");
            strcat(S,s1);
            break;
         }

         case 0x1D:
         {
            float tmpSnglSrc;
            float tmpSnglDst;
            char s1[20];
            fread(&tmpSnglSrc,sizeof(tmpSnglSrc),1,f);
            _fmsbintoieee(&tmpSnglSrc,&tmpSnglDst);
            sprintf(s1,"%f",tmpSnglDst);
            strcat(S,s1);
            break;
         }
         case 0x1F:
         {
            double tmpSnglSrc;
            double tmpSnglDst;
            char s1[20];
            fread(&tmpSnglSrc,sizeof(tmpSnglSrc),1,f);
            _dmsbintoieee(&tmpSnglSrc,&tmpSnglDst);
            sprintf(s1,"%f",tmpSnglDst);
            strcat(S,s1);
            break;
         }

         case '"':
         {
            strcat(S,"\"");
            unsigned char j;
            char s1[10];
            do
            {
               fread(&j,sizeof(j),1,f);
               if (j==0)
               {
                  goon = 0;
                  break;
               }
               sprintf(s1,"%c",j);
               strcat(S,s1);
            }
            while (j!='"');
            break;
         }

         case 0x81:
         {
            strcat(S,"END");
            break;
         }
         case 0x82:
         {
            strcat(S,"FOR");
            break;
         }
         case 0x83:
         {
            strcat(S,"NEXT");
            break;
         }
         case 0x85:
         {
            strcat(S,"INPUT");
            break;
         }
         case 0x86:
         {
            strcat(S,"DIM");
            break;
         }
         case 0x87:
         {
            strcat(S,"READ");
            break;
         }
         case 0x88:
         {
            strcat(S,"LET");
            break;
         }
         case 0x89:
         {
            strcat(S,"GOTO");
            break;
         }
         case 0x8A:
         {
            strcat(S,"RUN");
            break;
         }
         case 0x8B:
         {
            strcat(S,"IF");
            break;
         }
         case 0x8C:
         {
            strcat(S,"RESTORE");
            break;
         }
         case 0x8D:
         {
            strcat(S,"GOSUB");
            break;
         }
         case 0x8E:
         {
            strcat(S,"RETURN");
            break;
         }
         case 0x90:
         {
            strcat(S,"STOP");
            break;
         }
         case 0x91:
         {
            strcat(S,"PRINT");
            break;
         }
         case 0x92:
         {
            strcat(S,"CLEAR");
            break;
         }
         case 0x93:
         {
            strcat(S,"LIST");
            break;
         }
         case 0x94:
         {
            strcat(S,"NEW");
            break;
         }
         case 0x95:
         {
            strcat(S,"ON");
            break;
         }
         case 0x96:
         {
            strcat(S,"$");
            break;
         }
         case 0x98:
         {
            strcat(S,"DEF");
            break;
         }
         case 0x99:
         {
            strcat(S,"POKE");
            break;
         }
         case 0x9A:
         {
            strcat(S,"CONT");
            break;
         }
         case 0x9D:
         {
            strcat(S,"MOTOR");
            break;
         }
         case 0x9E:
         {
            strcat(S,"LPRINT");
            break;
         }
         case 0x9F:
         {
            strcat(S,"LLIST");
            break;
         }
         case 0xA1:
         {
            strcat(S,"WIDTH");
            break;
         }
         case 0xA2:
         {
            strcat(S,"ELSE");
            break;
         }
         case 0xA3:
         {
            strcat(S,"TRON");
            break;
         }
         case 0xA4:
         {
            strcat(S,"TROFF");
            break;
         }
         case 0xA5:
         {
            strcat(S,"SWAP");
            break;
         }
         case 0xA6:
         {
            strcat(S,"ERASE");
            break;
         }
         case 0xA7:
         {
            strcat(S,"EDIT");
            break;
         }
         case 0xA8:
         {
            strcat(S,"ERROR");
            break;
         }
         case 0xA9:
         {
            strcat(S,"RESUME");
            break;
         }
         case 0xAA:
         {
            strcat(S,"DELETE");
            break;
         }
         case 0xAB:
         {
            strcat(S,"AUTO");
            break;
         }
         case 0xAC:
         {
            strcat(S,"RENUM");
            break;
         }
         case 0xAD:
         {
            strcat(S,"DEFSTR");
            break;
         }
         case 0xAE:
         {
            strcat(S,"DEFINT");
            break;
         }
         case 0xAF:
         {
            strcat(S,"DEFSNG");
            break;
         }
         case 0xB0:
         {
            strcat(S,"DEFDBL");
            break;
         }
         case 0xB1:
         {
            strcat(S,"LINE");
            break;
         }
//         case 0xB2:
//         {
//          strcat(S,"SPEED");
//            break;
//         }
         case 0xBB:
         {
            strcat(S,"RANDOMIZE");
            break;
         }
         case 0xBC:
         {
            strcat(S,"BEEP");
            break;
         }
         case 0xBD:
         {
            strcat(S,"SYSTEM");
            break;
         }
         case 0xBF:
         {
            strcat(S,"OPEN");
            break;
         }
         case 0xC3:
         {
            strcat(S,"CLOSE");
            break;
         }
         case 0xC4:
         {
            strcat(S,"LOAD");
            break;
         }
         case 0xC5:
         {
            strcat(S,"MERGE");
            break;
         }
         case 0xC6:
         {
            strcat(S,"FILES");
            break;
         }
         case 0xC7:
         {
            strcat(S,"NAME");
            break;
         }
         case 0xC8:
         {
            strcat(S,"KILL");
            break;
         }
         case 0xCB:
         {
            strcat(S,"SAVE");
            break;
         }
         case 0xCD:
         {
            strcat(S,"LFILES");
            break;
         }
         case 0xCE:
         {
            strcat(S,"CLS");
            break;
         }
         case 0xCF:
         {
            strcat(S,"PCLS");
            break;
         }
         case 0xD0:
         {
            strcat(S,"COLOR");
            break;
         }
         case 0xD1:
         {
            strcat(S,"CIRCLE");
            break;
         }
         case 0xD2:
         {
            strcat(S,"DRAW");
            break;
         }
         case 0xD3:
         {
            strcat(S,"PAINT");
            break;
         }
         case 0xD4:
         {
            strcat(S,"PSET");
            break;
         }
         case 0xD5:
         {
            strcat(S,"PRESET");
            break;
         }
         case 0xD6:
         {
            strcat(S,"LOCATE");
            break;
         }
         case 0xD7:
         {
            strcat(S,"SCREEN");
            break;
         }
         case 0xD9:
         {
            strcat(S,"LUT");
            break;
         }
         case 0xDA:
         {
            strcat(S,"RELOC");
            break;
         }
         case 0xDC:
         {
            strcat(S,"TO");
            break;
         }
         case 0xDD:
         {
            strcat(S,"THEN");
            break;
         }
         case 0xDE:
         {
            strcat(S,"TAB(");
            break;
         }
         case 0xDF:
         {
            strcat(S,"STEP");
            break;
         }
         case 0xE0:
         {
            strcat(S,"USR");
            break;
         }
         case 0xE1:
         {
            strcat(S,"FN");
            break;
         }
         case 0xE2:
         {
            strcat(S,"SPC(");
            break;
         }
         case 0xE4:
         {
            strcat(S,"ERL");
            break;
         }
         case 0xE5:
         {
            strcat(S,"ERR");
            break;
         }
         case 0xE6:
         {
            strcat(S,"STRING$");
            break;
         }
         case 0xE7:
         {
            strcat(S,"USING");
            break;
         }
         case 0xE8:
         {
            strcat(S,"INSTR");
            break;
         }
         case 0xEA:
         {
            strcat(S,"VARPTR");
            break;
         }
         case 0xEB:
         {
            strcat(S,"CSRLIN");
            break;
         }
         case 0xEC:
         {
            strcat(S,"OFF");
            break;
         }
         case 0xED:
         {
            strcat(S,"INKEY$");
            break;
         }
         case 0xEE:
         {
            strcat(S,"POINT");
            break;
         }
         case 0xEF:
         {
            strcat(S,">");
            break;
         }
         case 0xF0:
         {
            strcat(S,"=");
            break;
         }
         case 0xF1:
         {
            strcat(S,"<");
            break;
         }
         case 0xF2:
         {
            strcat(S,"+");
            break;
         }
         case 0xF3:
         {
            strcat(S,"-");
            break;
         }
         case 0xF4:
         {
            strcat(S,"*");
            break;
         }
         case 0xF5:
         {
            strcat(S,"/");
            break;
         }
         case 0xF6:
         {
            strcat(S,"^");
            break;
         }
         case 0xF7:
         {
            strcat(S,"AND");
            break;
         }
         case 0xF8:
         {
            strcat(S,"OR");
            break;
         }
         case 0xF9:
         {
            strcat(S,"XOR");
            break;
         }
         case 0xFA:
         {
            strcat(S,"EQV");
            break;
         }
         case 0xFB:
         {
            strcat(S,"IMP");
            break;
         }
         case 0xFC:
         {
            strcat(S,"MOD");
            break;
         }
         case 0xFD:
         {
            strcat(S,"\\");
            break;
         }
         case 0xFF:
         {
            unsigned char j;
            fread(&j,sizeof(j),1,f);
            switch (j)
            {
               case 0x81:
               {
                  strcat(S,"LEFT$");
                  break;
               }
               case 0x82:
               {
                  strcat(S,"RIGHT$");
                  break;
               }
               case 0x83:
               {
                  strcat(S,"MID$");
                  break;
               }
               case 0x84:
               {
                  strcat(S,"SGN");
                  break;
               }
               case 0x85:
               {
                  strcat(S,"INT");
                  break;
               }
               case 0x86:
               {
                  strcat(S,"ABS");
                  break;
               }
               case 0x87:
               {
                  strcat(S,"SQR");
                  break;
               }
               case 0x88:
               {
                  strcat(S,"RND");
                  break;
               }
               case 0x89:
               {
                  strcat(S,"SIN");
                  break;
               }
               case 0x8A:
               {
                  strcat(S,"LOG");
                  break;
               }
               case 0x8B:
               {
                  strcat(S,"EXP");
                  break;
               }
               case 0x8C:
               {
                  strcat(S,"COS");
                  break;
               }
               case 0x8D:
               {
                  strcat(S,"TAN");
                  break;
               }
               case 0x8E:
               {
                  strcat(S,"ATN");
                  break;
               }
               case 0x8F:
               {
                  strcat(S,"FRE");
                  break;
               }
               case 0x90:
               {
                  strcat(S,"BIN$");
                  break;
               }
               case 0x91:
               {
                  strcat(S,"POS");
                  break;
               }
               case 0x92:
               {
                  strcat(S,"LEN");
                  break;
               }
               case 0x93:
               {
                  strcat(S,"STR$");
                  break;
               }
               case 0x94:
               {
                  strcat(S,"VAL");
                  break;
               }
               case 0x95:
               {
                  strcat(S,"ASC");
                  break;
               }
               case 0x96:
               {
                  strcat(S,"CHR$");
                  break;
               }
               case 0x97:
               {
                  strcat(S,"PEEK");
                  break;
               }
               case 0x98:
               {
                  strcat(S,"SPACE$");
                  break;
               }
               case 0x99:
               {
                  strcat(S,"OCT$");
                  break;
               }
               case 0x9A:
               {
                  strcat(S,"HEX$");
                  break;
               }
               case 0x9B:
               {
                  strcat(S,"LPOS");
                  break;
               }
               case 0x9C:
               {
                  strcat(S,"CINT");
                  break;
               }
               case 0x9D:
               {
                  strcat(S,"CSNG");
                  break;
               }
               case 0x9E:
               {
                  strcat(S,"CDBL");
                  break;
               }
               case 0x9F:
               {
                  strcat(S,"FIX");
                  break;
               }
               case 0xAF:
               {
                  strcat(S,"EOF");
                  break;
               }
               default:
               {
                  strcat(S,"  ");
                  char s1[10];
                  sprintf(s1,"%i",j);
                  strcat(S,s1);
               }
            }
            break;
         }
         default:
         {
            char s1[2];
            sprintf(s1,"%c",i);
            strcat(S,s1);
            break;
         }
      }
   }
   return S;
}
