/**************************************************/
/*                                                */
/* Copyright (C) 1997 Michael Radchenko           */
/* Portions Copyright (C) 2009 MarinovSoft        */
/*                                                */
/**************************************************/
#include <string.h>
#include <dir.h>
#include <stdlib.h>
#include "service.h"
char *separator(char *S, const char *title)
{
   char S1[77];
   for(unsigned char i = 0; i <= 75; i++)
   {
       S[i] = '-';
   }
   S[76] = 0;
   if(strlen(title) != 0)
   {
      strcpy(S1, "");
      strcat(S1, title);
      strcat(S1, "");
   }
   unsigned char ind1 = ((strlen(S) - strlen(S1)) / 2);
   unsigned char ind2 = ind1 + strlen(S1) - 1;
   for(i = ind1; i <= ind2; i++)
   {
       S[i] = S1[i - ind1];
   }
   return(S);
}

char *ChangeFileExt(char *NFileName, const char *FileName, const char *Extension)
{
   char drive[MAXDRIVE];
   char dir[MAXDIR];
   char file[MAXFILE];
   char ext[MAXEXT];

   fnsplit(FileName, drive, dir, file, ext);
   strcpy(NFileName, drive);
   strcat(NFileName, dir);
   strcat(NFileName, file);
   strcat(NFileName, Extension);
   return(NFileName);
}

char *GetFileExt(char *S, const char *FileName)
{
   char drive[MAXDRIVE];
   char dir[MAXDIR];
   char file[MAXFILE];
   char ext[MAXEXT];

   fnsplit(FileName, drive, dir, file, ext);
   strcpy(S, ext);
   return(S);
}

char *GetFileName(char *NFileName, const char *FileName)
{
   char drive[MAXDRIVE];
   char dir[MAXDIR];
   char file[MAXFILE];
   char ext[MAXEXT];

   fnsplit(FileName, drive, dir, file, ext);
   strcpy(NFileName, file);
   return(NFileName);
}

char *GetMSXFileName(char *NFileName, const char *FileName)
{
   GetFileName(NFileName, FileName);
   for(; strlen(NFileName) < 6; )
   {
       strcat(NFileName, " ");
   }
   NFileName[7] = 0;
   return(NFileName);
}