#define Uses_TStaticText
#define Uses_TScroller
#include <tv.h>
#include "growview.h"
#define MaxLinesCount 200
#define MaxLineLength 100
typedef
   char TStringBuf[MaxLinesCount][MaxLineLength];
/***************************************************************************/
class TProgressDialog:public TDialog
{
public:
        TProgressDialog(const char *ATitle);
        void update(long val);
//   void SetCurrentText(const char *AText);
//   void SetTotalText(const char *AText);
protected:
        TStaticText *CurrentText;
        TStaticText *TotalText;
        TGrowView *GV1;
};
/***************************************************************************/
class TColorText:public TScroller
{
public:
        short int LinesCount;
        TStringBuf StrBuf;
        unsigned short Color;
        short int FirstLine;
        TColorText(TRect& Bounds, TScrollBar *AHScrollBar, TScrollBar *AVScrollBar);
        virtual void writeLineAt(short int LineNumber, char *S);
        virtual void writeLine(char *S);
        virtual void FillBuf(char *S, TDrawBuffer& Buf);
        virtual void calcBounds(TRect& Bounds, TPoint D);
        virtual TPalette& getPalette() const;
        virtual void draw();
};
/***************************************************************************/
class TInfoWindow:public TWindow
{
public:
        TColorText *ScreenText;
        TInfoWindow(char *titul);
//      ~TInfoWindow();
        virtual void draw();
        short int GetLinesCount();
        virtual void writeLineAt(short int LineNumber, char *S);
        virtual void writeLine(char *S);
};
/***************************************************************************/
