#define Uses_TView
#define Uses_TRect
#define Uses_TPalette
#include <tv.h>
#include "growview.h"

#define cpGrowViewPalette    "\06\09"

TGrowView::TGrowView(TRect& R, long ATotal) : TView(R)
{
   Total    = ATotal;
   Value    = 0;
   NumBlock = 0;
}

TGrowView::~TGrowView()
{
}

short int TGrowView::CalcBlock()
{
   return((Value * size.x) / Total);
}

void TGrowView::draw()
{
//      TRect R;
   TDrawBuffer B;

   B.moveChar(0, '', getColor(1), size.x);
   B.moveChar(0, '', getColor(1), NumBlock);
   writeLine(0, 0, size.x, size.y, B);
}

TPalette& TGrowView::getPalette() const
{
   static TPalette palette(cpGrowViewPalette, sizeof(cpGrowViewPalette) - 1);

   return(palette);
}

void TGrowView::update(long NewValue)
{
   short int NewBlock;

   if(Value != NewValue)
   {
      Value    = NewValue;
      NewBlock = CalcBlock();
      if(NewBlock != NumBlock)
      {
         NumBlock = NewBlock;
         draw();
      }
   }
}