/**************************************************/
/*                                                */
/*       Copyright (C) 2011 MarinovSoft           */
/*                                                */
/**************************************************/

#define Uses_TDialog
#define Uses_TButton
#define Uses_TLabel
#define Uses_TInputLine
#define Uses_TRect

#include <tv.h>
#include "optdlg.h"

TOptDialog::TOptDialog() :
    TDialog( TRect(0, 0, 34, 12), "Options" ),
    TWindowInit( &TOptDialog::initFrame )
{
    TRect r(3, 4, 30, 5);

    options |= ofCentered;

    LoadAddrLine = new TInputLine( TRect( 17, 2, 24, 3 ), 6 );
    insert( LoadAddrLine );

    StartAddrLine = new TInputLine( TRect( 17, 4, 24, 5 ), 6 );
    insert( StartAddrLine );

    r = TRect(2, 2, 15, 3);
    insert(new TLabel(r, "LoadAddr = ", NULL));

    r = TRect(2, 4, 15, 5);
    insert(new TLabel(r, "StartAddr = ",  NULL));

    r = TRect(6, 9, 16, 11);
    insert(new TButton(r, "O~K~", cmOK, bfDefault));

    r = TRect(18, 9, 28, 11);
    insert(new TButton(r, "Cancel", cmCancel, bfNormal));

    selectNext( (Boolean) 0);
}
